Loading...
Searching...
No Matches
pcl::kinfuLS::WorldModel< PointT > Class Template Reference

WorldModel maintains a 3D point cloud that can be queried and updated via helper functions. More...

`#include </build/pcl-Jv4Ahb/pcl-1.14.0+dfsg/gpu/kinfu_large_scale/include/pcl/gpu/kinfu_large_scale/world_model.h>`

## Public Types

using | Ptr = shared_ptr< WorldModel< PointT > >
using | ConstPtr = shared_ptr< const WorldModel< PointT > >
using | PointCloud = pcl::PointCloud< PointT >
using | PointCloudPtr = typename PointCloud::Ptr
using | PointCloudConstPtr = typename PointCloud::ConstPtr
using | ConditionAndPtr = typename pcl::ConditionAnd< PointT >::Ptr
using | ConditionOrPtr = typename pcl::ConditionOr< PointT >::Ptr
using | FieldComparisonConstPtr = typename pcl::FieldComparison< PointT >::ConstPtr
using | FieldList = typename pcl::traits::fieldList< PointT >::type

## Public Member Functions

| WorldModel ()
| Default constructor for the WorldModel.
void | reset ()
| Clear the world.
void | addSlice (const PointCloudPtr new_cloud)
| Append a new point cloud (slice) to the world.
void | getExistingData (const double previous_origin_x, const double previous_origin_y, const double previous_origin_z, const double offset_x, const double offset_y, const double offset_z, const double volume_x, const double volume_y, const double volume_z, pcl::PointCloud< PointT > &existing_slice)
| Retrieve existing data from the world model, after a shift.
void | setSliceAsNans (const double origin_x, const double origin_y, const double origin_z, const double offset_x, const double offset_y, const double offset_z, const int size_x, const int size_y, const int size_z)
| Give nan values to the slice of the world.
void | cleanWorldFromNans ()
| Remove points with nan values from the world.
PointCloudPtr | getWorld ()
| Returns the world as a point cloud.
std::size_t | getWorldSize ()
| Returns the number of points contained in the world.
void | getWorldAsCubes (double size, std::vector< PointCloudPtr > &cubes, std::vector< Eigen::Vector3f, Eigen::aligned_allocator< Eigen::Vector3f > > &transforms, double overlap=0.0)
| Returns the world as two vectors of cubes of size "size" (pointclouds) and transforms.

## Detailed Description

template<typename PointT>
class pcl::kinfuLS::WorldModel< PointT >

WorldModel maintains a 3D point cloud that can be queried and updated via helper functions.

The world is represented as a point cloud.
When new points are added to the world, we replace old ones by the newest ones. This is achieved by setting old points to nan (for speed)

Author
  Raphael Favier

Definition at line 62 of file world_model.h.

## Member Typedef Documentation

## ConditionAndPtr

template<typename PointT >

using pcl::kinfuLS::WorldModel< PointT >::ConditionAndPtr = typename pcl::ConditionAnd<PointT>::Ptr

Definition at line 73 of file world_model.h.

## ConditionOrPtr

template<typename PointT >

using pcl::kinfuLS::WorldModel< PointT >::ConditionOrPtr = typename pcl::ConditionOr<PointT>::Ptr

Definition at line 74 of file world_model.h.

## ConstPtr

template<typename PointT >

using pcl::kinfuLS::WorldModel< PointT >::ConstPtr = shared_ptr<const WorldModel<PointT> >

Definition at line 67 of file world_model.h.

## FieldComparisonConstPtr

template<typename PointT >

using pcl::kinfuLS::WorldModel< PointT >::FieldComparisonConstPtr = typename pcl::FieldComparison<PointT>::ConstPtr

Definition at line 75 of file world_model.h.

## FieldList

template<typename PointT >

using pcl::kinfuLS::WorldModel< PointT >::FieldList = typename pcl::traits::fieldList<PointT>::type

Definition at line 77 of file world_model.h.

## PointCloud

template<typename PointT >

using pcl::kinfuLS::WorldModel< PointT >::PointCloud = pcl::PointCloud<PointT>

Definition at line 69 of file world_model.h.

## PointCloudConstPtr

template<typename PointT >

using pcl::kinfuLS::WorldModel< PointT >::PointCloudConstPtr = typename PointCloud::ConstPtr

Definition at line 71 of file world_model.h.

## PointCloudPtr

template<typename PointT >

using pcl::kinfuLS::WorldModel< PointT >::PointCloudPtr = typename PointCloud::Ptr

Definition at line 70 of file world_model.h.

## Ptr

template<typename PointT >

using pcl::kinfuLS::WorldModel< PointT >::Ptr = shared_ptr<WorldModel<PointT> >

Definition at line 66 of file world_model.h.

## Constructor & Destructor Documentation

## WorldModel()

template<typename PointT >

pcl::kinfuLS::WorldModel< PointT >::WorldModel | ( |  | ) |

inline

Default constructor for the WorldModel.

Definition at line 81 of file world_model.h.

## Member Function Documentation

## addSlice()

template<typename PointT >

void pcl::kinfuLS::WorldModel< PointT >::addSlice | ( | const PointCloudPtr | new_cloud | ) |

Append a new point cloud (slice) to the world.

Parameters

  [in] | new_cloud | the point cloud to add to the world

Definition at line 47 of file world_model.hpp.

## cleanWorldFromNans()

template<typename PointT >

void pcl::kinfuLS::WorldModel< PointT >::cleanWorldFromNans | ( |  | ) |

inline

Remove points with nan values from the world.

Definition at line 137 of file world_model.h.

References pcl::removeNaNFromPointCloud().

## getExistingData()

template<typename PointT >

void pcl::kinfuLS::WorldModel< PointT >::getExistingData | ( | const double | previous_origin_x,
|  | const double | previous_origin_y,
|  | const double | previous_origin_z,
|  | const double | offset_x,
|  | const double | offset_y,
|  | const double | offset_z,
|  | const double | volume_x,
|  | const double | volume_y,
|  | const double | volume_z,
|  | pcl::PointCloud< PointT > & | existing_slice
| ) |  |

Retrieve existing data from the world model, after a shift.

Parameters

  [in] | previous_origin_x | global origin of the cube on X axis, before the shift
  [in] | previous_origin_y | global origin of the cube on Y axis, before the shift
  [in] | previous_origin_z | global origin of the cube on Z axis, before the shift
  [in] | offset_x | shift on X, in indices
  [in] | offset_y | shift on Y, in indices
  [in] | offset_z | shift on Z, in indices
  [in] | volume_x | size of the cube, X axis, in indices
  [in] | volume_y | size of the cube, Y axis, in indices
  [in] | volume_z | size of the cube, Z axis, in indices
  [out] | existing_slice | the extracted point cloud representing the slice

Definition at line 63 of file world_model.hpp.

References pcl::Filter< PointT >::filter(), pcl::ComparisonOps::GE, pcl::ComparisonOps::LT, pcl::ConditionalRemoval< PointT >::setCondition(), pcl::PCLBase< PointT >::setInputCloud(), and pcl::ConditionalRemoval< PointT >::setKeepOrganized().

## getWorld()

template<typename PointT >

PointCloudPtr pcl::kinfuLS::WorldModel< PointT >::getWorld | ( |  | ) |

inline

Returns the world as a point cloud.

Definition at line 146 of file world_model.h.

## getWorldAsCubes()

template<typename PointT >

void pcl::kinfuLS::WorldModel< PointT >::getWorldAsCubes | ( | double | size,
|  | std::vector< PointCloudPtr > & | cubes,
|  | std::vector< Eigen::Vector3f, Eigen::aligned_allocator< Eigen::Vector3f > > & | transforms,
|  | double | overlap = `0.0`
| ) |  |

Returns the world as two vectors of cubes of size "size" (pointclouds) and transforms.

Parameters

  [in] | size | the size of a 3D cube.
  [out] | cubes | a vector of point clouds representing each cube (in their original world coordinates).
  [out] | transforms | a vector containing the xyz position of each cube in world coordinates.
  [in] | overlap | optional overlap (in percent) between each cube (useful to create overlapped meshes).

Definition at line 136 of file world_model.hpp.

References pcl::removeNaNFromPointCloud().

## getWorldSize()

template<typename PointT >

std::size_t pcl::kinfuLS::WorldModel< PointT >::getWorldSize | ( |  | ) |

inline

Returns the number of points contained in the world.

Definition at line 153 of file world_model.h.

## reset()

template<typename PointT >

void pcl::kinfuLS::WorldModel< PointT >::reset | ( |  | ) |

inline

Clear the world.

Definition at line 89 of file world_model.h.

## setSliceAsNans()

template<typename PointT >

void pcl::kinfuLS::WorldModel< PointT >::setSliceAsNans | ( | const double | origin_x,
|  | const double | origin_y,
|  | const double | origin_z,
|  | const double | offset_x,
|  | const double | offset_y,
|  | const double | offset_z,
|  | const int | size_x,
|  | const int | size_y,
|  | const int | size_z
| ) |  |

Give nan values to the slice of the world.

Parameters

  [in] | origin_x | global origin of the cube on X axis, before the shift
  [in] | origin_y | global origin of the cube on Y axis, before the shift
  [in] | origin_z | global origin of the cube on Z axis, before the shift
  [in] | offset_x | shift on X, in indices
  [in] | offset_y | shift on Y, in indices
  [in] | offset_z | shift on Z, in indices
  [in] | size_x | size of the cube, X axis, in indices
  [in] | size_y | size of the cube, Y axis, in indices
  [in] | size_z | size of the cube, Z axis, in indices

Definition at line 275 of file world_model.hpp.

References pcl::Filter< PointT >::filter(), pcl::ComparisonOps::GE, pcl::Filter< PointT >::getRemovedIndices(), pcl::ComparisonOps::LT, pcl::ConditionalRemoval< PointT >::setCondition(), pcl::PCLBase< PointT >::setInputCloud(), and pcl::ConditionalRemoval< PointT >::setKeepOrganized().

The documentation for this class was generated from the following files:

- /build/pcl-Jv4Ahb/pcl-1.14.0+dfsg/gpu/kinfu_large_scale/include/pcl/gpu/kinfu_large_scale/world_model.h
- /build/pcl-Jv4Ahb/pcl-1.14.0+dfsg/gpu/kinfu_large_scale/include/pcl/gpu/kinfu_large_scale/impl/world_model.hpp